#
# spec file for package perl-Makefile-DOM
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-Makefile-DOM
Version:        0.008
Release:        4.5
%define cpan_name Makefile-DOM
Summary:        Simple DOM parser for Makefiles
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/Makefile-DOM/
Source:         http://www.cpan.org/authors/id/A/AG/AGENT/%{cpan_name}-%{version}.tar.gz
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Clone) >= 0.18
BuildRequires:  perl(List::MoreUtils) >= 0.21
BuildRequires:  perl(Params::Util) >= 0.22
Requires:       perl(Clone) >= 0.18
Requires:       perl(List::MoreUtils) >= 0.21
Requires:       perl(Params::Util) >= 0.22
%{perl_requires}

%description
This libary can serve as an advanced lexer for (GNU) makefiles. It parses
makefiles as "documents" and the parsing is lossless. The results are data
structures similar to DOM trees. The DOM trees hold every single bit of the
information in the original input files, including white spaces, blank
lines and makefile comments. That means it's possible to reproduce the
original makefiles from the DOM trees. In addition, each node of the DOM
trees is modifiable and so is the whole tree, just like the the PPI manpage
module used for Perl source parsing and the the HTML::TreeBuilder manpage
module used for parsing HTML source.

If you're looking for a true GNU make parser that generates an AST, please
see the Makefile::Parser::GmakeDB manpage instead.

The interface of 'Makefile::DOM' mimics the API design of the PPI manpage.
In fact, I've directly stolen the source code and POD documentation of the
PPI::Node manpage, the PPI::Element manpage, and the PPI::Dumper manpage,
with the full permission from the author of the PPI manpage, Adam Kennedy.

'Makefile::DOM' tries to be independent of specific makefile's syntax. The
same set of DOM node types is supposed to get shared by different makefile
DOM generators. For example, the MDOM::Document::Gmake manpage parses GNU
makefiles and returns an instance of the MDOM::Document manpage, i.e., the
root of the DOM tree while the NMAKE makefile lexer in the future,
'MDOM::Document::Nmake', also returns instances of the the MDOM::Document
manpage class. Later, I'll also consider adding support for dmake and
bsdmake.

%prep
%setup -q -n %{cpan_name}-%{version}
find . -type f -print0 | xargs -0 chmod 644

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes README TODO

%changelog
* Tue Apr 14 2015 coolo@suse.com
- updated to 0.008
  see /usr/share/doc/packages/perl-Makefile-DOM/Changes
  0.008  2014-11-18
  * bugfix: fixed a regression in 0.007 which changed the API of MDOM::Document::Gmake
    and broke backward-compatibility.
  0.007  2014-11-18
  * bugfix: The test file pod-coverage.t was failing. thanks ambs (Alberto Simões)
    for the original patch.
* Fri Nov 18 2011 coolo@suse.com
- update to 0.006
  * Fixed a syntax error in the POD documentation. thanks Mikhail Gusarov.
  * Updated the author name, author email address, and code repository in the documentation.
  * Updated the bundled Module::Install to the latest version, 1.01.
* Wed Dec  1 2010 coolo@novell.com
- switch to perl_requires macro
* Fri Nov 12 2010 jw@novell.com
- needed by Makefile::Parser, publican
- initial package 0.004
  * created by cpanspec 1.78.02
